package com.example.julian.endlessroll.entities.textures;

import android.content.Context;
import android.support.annotation.DrawableRes;

import com.example.julian.endlessroll.R;
import com.example.julian.endlessroll.entities.tools.ToolType;
import com.example.julian.endlessroll.levels.worlds.World;

import java.util.HashMap;
import java.util.Map;

/**
 * Created by Julian on 05.12.2015.
 */
public class TexturePack {

    private TextureLoader loader;

    public final Texture goal;
    public final Texture playerArrow;
    public final Texture player;
    public final Texture star;
    public final Texture blueParticle;
    public final Texture yellowParticle;
    public final Texture redParticle;

    public TexturePack(Context context) {
        loader = new TextureLoader(context);
        goal = loadTexture(R.drawable.goal);
        player = loadTexture(R.drawable.ball);
        playerArrow = loadTexture(R.drawable.playerarrow);

        star = loadTexture(R.drawable.star);

        blueParticle = loadTexture(R.drawable.blueparticle);
        yellowParticle = loadTexture(R.drawable.yellowparticle);
        redParticle = loadTexture(R.drawable.redparticle);

        ToolType.loadAllToolTextures(this);
        World.loadAllSpecificTextures(this);
    }

    public Texture loadTexture(@DrawableRes int id) {
        int texId = loader.loadTextureId(id, false);
        return new Texture(texId, 1, 1);
    }

    public Texture loadAtlas(@DrawableRes int id, int atlasWidth, int atlasHeight) {
        int texId = loader.loadTextureId(id, true);
        return new Texture(texId, atlasWidth, atlasHeight);
    }
}
