package com.example.julian.endlessroll.levels;

import org.simpleframework.xml.Attribute;
import org.simpleframework.xml.ElementList;

import java.util.List;

/**
 * Created by Julian on 07.12.2015.
 */
public class Level {

    @Attribute
    private int number;
    @Attribute
    private float goalX;
    @Attribute
    private float startSpeed;
    @Attribute
    private float endSpeed;
    @Attribute
    private float terrainEdge;
    @Attribute
    private float ceilingEdge;
    @ElementList
    private List<TileData> terrainTiles;
    @ElementList
    private List<TileData> ceilingTiles;
    @ElementList
    private List<ObstacleData> obstacles;
    @ElementList
    private List<StarData> stars;

    private boolean completed;
    private boolean unlocked;
    private boolean firstStarCollected;
    private boolean secondStarCollected;
    private boolean thirdStarCollected;

    public int getNumber() {
        return number;
    }

    public float getGoalX() {
        return goalX;
    }

    public float getStartSpeed() {
        return startSpeed;
    }

    public float getEndSpeed() {
        return endSpeed;
    }

    public float getTerrainEdge() {
        return terrainEdge;
    }

    public float getCeilingEdge() {
        return ceilingEdge;
    }

    public List<TileData> getTerrainTiles() {
        return terrainTiles;
    }

    public List<TileData> getCeilingTiles() {
        return ceilingTiles;
    }

    public List<ObstacleData> getObstacles() {
        return obstacles;
    }

    public List<StarData> getStars() {
        return stars;
    }

    public boolean isUnlocked() {
        return unlocked;
    }

    public void setUnlocked(boolean unlocked) {
        this.unlocked = unlocked;
    }

    public boolean isCompleted() {
        return completed;
    }

    public void setCompleted(boolean completed) {
        this.completed = completed;
    }

    public boolean isFirstStarCollected() {
        return firstStarCollected;
    }

    public boolean isSecondStarCollected() {
        return secondStarCollected;
    }

    public boolean isThirdStarCollected() {
        return thirdStarCollected;
    }

    public void setStarCollected(int index, boolean collected){
        if(index == 1)
            firstStarCollected = collected;
        else if(index == 2)
            secondStarCollected = collected;
        else if(index == 3)
            thirdStarCollected = collected;
    }

    public String getCollectedStars(){
        String code = "";
        code+= firstStarCollected?"1":"";
        code+= secondStarCollected?"2":"";
        code+= thirdStarCollected?"3":"";
        return code;
    }

    public void setCollectedStars(String code){
        firstStarCollected = code.contains("1");
        secondStarCollected = code.contains("2");
        thirdStarCollected = code.contains("3");
    }

    public void reset(){
        completed = false;
        unlocked = false;
        firstStarCollected = false;
        secondStarCollected = false;
        thirdStarCollected = false;
    }

}
